# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from squirrel_mhand_msgs/Joints.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import squirrel_mhand_msgs.msg

class Joints(genpy.Message):
  _md5sum = "d1ab098e0d06d504d5ca5a1e170f503d"
  _type = "squirrel_mhand_msgs/Joints"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """int16 joint_list_length
Joint[] joint_list

================================================================================
MSG: squirrel_mhand_msgs/Joint
string joint_name
float64 joint_angle
float64 joint_angle_setpoint_tracked
float64 joint_angle_setpoint_next
float64 joint_effort
float64 joint_effort_setpoint_tracked
float64 joint_effort_setpoint_next
float64 joint_velocity
bool joint_effort_control_enabled
string joint_status
"""
  __slots__ = ['joint_list_length','joint_list']
  _slot_types = ['int16','squirrel_mhand_msgs/Joint[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       joint_list_length,joint_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Joints, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint_list_length is None:
        self.joint_list_length = 0
      if self.joint_list is None:
        self.joint_list = []
    else:
      self.joint_list_length = 0
      self.joint_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_h.pack(self.joint_list_length))
      length = len(self.joint_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_list:
        _x = val1.joint_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_7dB.pack(_x.joint_angle, _x.joint_angle_setpoint_tracked, _x.joint_angle_setpoint_next, _x.joint_effort, _x.joint_effort_setpoint_tracked, _x.joint_effort_setpoint_next, _x.joint_velocity, _x.joint_effort_control_enabled))
        _x = val1.joint_status
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.joint_list is None:
        self.joint_list = None
      end = 0
      start = end
      end += 2
      (self.joint_list_length,) = _struct_h.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_list = []
      for i in range(0, length):
        val1 = squirrel_mhand_msgs.msg.Joint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.joint_name = str[start:end].decode('utf-8')
        else:
          val1.joint_name = str[start:end]
        _x = val1
        start = end
        end += 57
        (_x.joint_angle, _x.joint_angle_setpoint_tracked, _x.joint_angle_setpoint_next, _x.joint_effort, _x.joint_effort_setpoint_tracked, _x.joint_effort_setpoint_next, _x.joint_velocity, _x.joint_effort_control_enabled,) = _struct_7dB.unpack(str[start:end])
        val1.joint_effort_control_enabled = bool(val1.joint_effort_control_enabled)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.joint_status = str[start:end].decode('utf-8')
        else:
          val1.joint_status = str[start:end]
        self.joint_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_h.pack(self.joint_list_length))
      length = len(self.joint_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_list:
        _x = val1.joint_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_7dB.pack(_x.joint_angle, _x.joint_angle_setpoint_tracked, _x.joint_angle_setpoint_next, _x.joint_effort, _x.joint_effort_setpoint_tracked, _x.joint_effort_setpoint_next, _x.joint_velocity, _x.joint_effort_control_enabled))
        _x = val1.joint_status
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.joint_list is None:
        self.joint_list = None
      end = 0
      start = end
      end += 2
      (self.joint_list_length,) = _struct_h.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_list = []
      for i in range(0, length):
        val1 = squirrel_mhand_msgs.msg.Joint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.joint_name = str[start:end].decode('utf-8')
        else:
          val1.joint_name = str[start:end]
        _x = val1
        start = end
        end += 57
        (_x.joint_angle, _x.joint_angle_setpoint_tracked, _x.joint_angle_setpoint_next, _x.joint_effort, _x.joint_effort_setpoint_tracked, _x.joint_effort_setpoint_next, _x.joint_velocity, _x.joint_effort_control_enabled,) = _struct_7dB.unpack(str[start:end])
        val1.joint_effort_control_enabled = bool(val1.joint_effort_control_enabled)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.joint_status = str[start:end].decode('utf-8')
        else:
          val1.joint_status = str[start:end]
        self.joint_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_h = struct.Struct("<h")
_struct_7dB = struct.Struct("<7dB")
